/**
 * Original Author -> 杨海健 (taketoday@foxmail.com) https://taketoday.cn
 * Copyright © TODAY & 2017 - 2019 All Rights Reserved.
 * 
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package cn.taketoday.web.annotation;

import cn.taketoday.context.Constant;
import cn.taketoday.web.RequestMethod;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 
 * @author Today <br>
 * 
 *         2018-07-01 14:08:28
 */
@Retention(RetentionPolicy.RUNTIME)
@ActionMapping(method = RequestMethod.POST)
@Target({ ElementType.METHOD, ElementType.TYPE })
public @interface POST {

	/**
	 * urls
	 * 
	 * @return
	 */
	String[] value() default Constant.BLANK;
	
	
	/**
	 * Exclude url on class
	 * 
	 * @return
	 */
	boolean exclude() default false;

}
